"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ChromeInputType = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _colorConvert = require("@uiw/color-convert");
var _reactColorGithub = _interopRequireWildcard(require("@uiw/react-color-github"));
var _reactColorSaturation = _interopRequireDefault(require("@uiw/react-color-saturation"));
var _reactColorHue = _interopRequireDefault(require("@uiw/react-color-hue"));
var _reactColorAlpha = _interopRequireDefault(require("@uiw/react-color-alpha"));
var _reactColorEditableInput = _interopRequireDefault(require("@uiw/react-color-editable-input"));
var _reactColorEditableInputRgba = _interopRequireDefault(require("@uiw/react-color-editable-input-rgba"));
var _reactColorEditableInputHsla = _interopRequireDefault(require("@uiw/react-color-editable-input-hsla"));
var _Arrow = _interopRequireDefault(require("./Arrow"));
var _EyeDropper = require("./EyeDropper");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["prefixCls", "className", "style", "color", "showEditableInput", "showEyeDropper", "showColorPreview", "showHue", "showAlpha", "inputType", "rectProps", "onChange"];
var ChromeInputType = exports.ChromeInputType = /*#__PURE__*/function (ChromeInputType) {
  ChromeInputType["HEXA"] = "hexa";
  ChromeInputType["RGBA"] = "rgba";
  ChromeInputType["HSLA"] = "hsla";
  return ChromeInputType;
}({});
var Chrome = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _props$prefixCls = props.prefixCls,
    prefixCls = _props$prefixCls === void 0 ? 'w-color-chrome' : _props$prefixCls,
    className = props.className,
    style = props.style,
    color = props.color,
    _props$showEditableIn = props.showEditableInput,
    showEditableInput = _props$showEditableIn === void 0 ? true : _props$showEditableIn,
    _props$showEyeDropper = props.showEyeDropper,
    showEyeDropper = _props$showEyeDropper === void 0 ? true : _props$showEyeDropper,
    _props$showColorPrevi = props.showColorPreview,
    showColorPreview = _props$showColorPrevi === void 0 ? true : _props$showColorPrevi,
    _props$showHue = props.showHue,
    showHue = _props$showHue === void 0 ? true : _props$showHue,
    _props$showAlpha = props.showAlpha,
    showAlpha = _props$showAlpha === void 0 ? true : _props$showAlpha,
    _props$inputType = props.inputType,
    inputType = _props$inputType === void 0 ? ChromeInputType.RGBA : _props$inputType,
    _props$rectProps = props.rectProps,
    rectProps = _props$rectProps === void 0 ? {} : _props$rectProps,
    onChange = props.onChange,
    other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var hsva = typeof color === 'string' && (0, _colorConvert.validHex)(color) ? (0, _colorConvert.hexToHsva)(color) : color || {
    h: 0,
    s: 0,
    l: 0,
    a: 0
  };
  var handleChange = function handleChange(hsv) {
    return onChange && onChange((0, _colorConvert.color)(hsv));
  };
  var _useState = (0, _react.useState)(inputType),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    type = _useState2[0],
    setType = _useState2[1];
  var handleClick = function handleClick() {
    if (type === ChromeInputType.RGBA) {
      setType(ChromeInputType.HSLA);
    }
    if (type === ChromeInputType.HSLA) {
      setType(ChromeInputType.HEXA);
    }
    if (type === ChromeInputType.HEXA) {
      setType(ChromeInputType.RGBA);
    }
  };
  var labelStyle = {
    paddingTop: 6
  };
  var inputStyle = {
    textAlign: 'center',
    paddingTop: 4,
    paddingBottom: 4
  };
  var wrapperStyle = (0, _objectSpread2["default"])({
    '--chrome-arrow-fill': '#333',
    '--chrome-arrow-background-color': '#e8e8e8',
    borderRadius: 0,
    flexDirection: 'column',
    width: 230,
    padding: 0
  }, style);
  var alphaStyle = {
    '--chrome-alpha-box-shadow': 'rgb(0 0 0 / 25%) 0px 0px 1px inset',
    borderRadius: '50%',
    background: (0, _colorConvert.hsvaToRgbaString)(hsva),
    boxShadow: 'var(--chrome-alpha-box-shadow)'
  };
  var handleClickColor = function handleClickColor(hex) {
    var result = (0, _colorConvert.hexToHsva)(hex);
    handleChange((0, _objectSpread2["default"])({}, result));
  };
  var styleSize = {
    height: 14,
    width: 14
  };
  var pointerProps = {
    style: (0, _objectSpread2["default"])({}, styleSize),
    fillProps: {
      style: styleSize
    }
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorGithub["default"], (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    ref: ref,
    color: hsva,
    style: wrapperStyle,
    colors: undefined,
    className: [prefixCls, className].filter(Boolean).join(' '),
    placement: _reactColorGithub.GithubPlacement.TopLeft
  }, other), {}, {
    addonAfter: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react.Fragment, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorSaturation["default"], {
        hsva: hsva,
        style: {
          width: '100%',
          height: 130
        },
        onChange: function onChange(newColor) {
          handleChange((0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, hsva), newColor), {}, {
            a: hsva.a
          }));
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        style: {
          padding: 15,
          display: 'flex',
          alignItems: 'center',
          gap: 10
        },
        children: [(0, _EyeDropper.getIsEyeDropperSupported)() && showEyeDropper && /*#__PURE__*/(0, _jsxRuntime.jsx)(_EyeDropper.EyeDropper, {
          onPickColor: handleClickColor
        }), showColorPreview && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorAlpha["default"], {
          width: 28,
          height: 28,
          hsva: hsva,
          radius: 2,
          style: {
            borderRadius: '50%'
          },
          bgProps: {
            style: {
              background: 'transparent'
            }
          },
          innerProps: {
            style: alphaStyle
          },
          pointer: function pointer() {
            return /*#__PURE__*/(0, _jsxRuntime.jsx)(_react.Fragment, {});
          }
        }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          style: {
            flex: 1
          },
          children: [showHue == true && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorHue["default"], {
            hue: hsva.h,
            style: {
              width: '100%',
              height: 12,
              borderRadius: 2
            },
            pointerProps: pointerProps,
            bgProps: {
              style: {
                borderRadius: 2
              }
            },
            onChange: function onChange(newHue) {
              handleChange((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, hsva), newHue));
            }
          }), showAlpha == true && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorAlpha["default"], {
            hsva: hsva,
            style: {
              marginTop: 6,
              height: 12,
              borderRadius: 2
            },
            pointerProps: pointerProps,
            bgProps: {
              style: {
                borderRadius: 2
              }
            },
            onChange: function onChange(newAlpha) {
              handleChange((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, hsva), newAlpha));
            }
          })]
        })]
      }), showEditableInput && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        style: {
          display: 'flex',
          alignItems: 'flex-start',
          padding: '0 15px 15px 15px',
          userSelect: 'none'
        },
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          style: {
            flex: 1
          },
          children: [type == ChromeInputType.RGBA && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorEditableInputRgba["default"], {
            hsva: hsva,
            rProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            gProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            bProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            aProps: showAlpha == false ? false : {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            onChange: function onChange(reColor) {
              return handleChange(reColor.hsva);
            }
          }), type === ChromeInputType.HEXA && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorEditableInput["default"], {
            label: "HEX",
            labelStyle: labelStyle,
            inputStyle: inputStyle,
            value: hsva.a > 0 && hsva.a < 1 ? (0, _colorConvert.hsvaToHexa)(hsva).toLocaleUpperCase() : (0, _colorConvert.hsvaToHex)(hsva).toLocaleUpperCase(),
            onChange: function onChange(_, value) {
              if (typeof value === 'string') {
                handleChange((0, _colorConvert.hexToHsva)(/^#/.test(value) ? value : "#".concat(value)));
              }
            }
          }), type === ChromeInputType.HSLA && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactColorEditableInputHsla["default"], {
            hsva: hsva,
            hProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            sProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            lProps: {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            aProps: showAlpha == false ? false : {
              labelStyle: labelStyle,
              inputStyle: inputStyle
            },
            onChange: function onChange(reColor) {
              return handleChange(reColor.hsva);
            }
          })]
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Arrow["default"], {
          onClick: handleClick
        })]
      })]
    }),
    rectRender: function rectRender() {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_react.Fragment, {});
    }
  }));
});
Chrome.displayName = 'Chrome';
var _default = exports["default"] = Chrome;